<!DOCTYPE html>
<html lang="fa">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>دانلود فایل</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f0f0f0;
            display: flex;
            justify-content: center;
            align-items: center;
            height: 100vh;
            margin: 0;
        }

        .container {
            background-color: #fff;
            padding: 30px;
            border-radius: 10px;
            box-shadow: 0 4px 10px rgba(0, 0, 0, 0.1);
            width: 100%;
            max-width: 400px;
            text-align: center;
        }

        h1 {
            font-size: 1.5rem;
            color: #333;
            margin-bottom: 20px;
        }

        label {
            display: block;
            font-size: 1rem;
            margin-bottom: 10px;
            color: #555;
        }

        input[type="text"] {
            width: 100%;
            padding: 10px;
            font-size: 1rem;
            border: 1px solid #ccc;
            border-radius: 5px;
            margin-bottom: 20px;
            box-sizing: border-box;
        }

        input[type="submit"] {
            background-color: #4CAF50;
            color: white;
            border: none;
            padding: 12px 20px;
            font-size: 1rem;
            cursor: pointer;
            border-radius: 25px;
            transition: background-color 0.3s ease;
            width: 100%;
        }

        input[type="submit"]:hover {
            background-color: #45a049;
        }

        .message {
            margin-top: 20px;
            font-size: 1rem;
            color: #333;
        }
    </style>
</head>
<body>

<div class="container">
    <h1>دانلود فایل</h1>

    <?php
    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        $url = $_POST['file_url'];
        $newfname = basename($url); // استخراج نام فایل از URL

        echo "<div class='message'>دانلود شروع شد!</div>";
        echo "<div class='message'>در حال دانلود، لطفاً منتظر بمانید...</div>";

        $file = fopen($url, "rb");
        if ($file) {
            $newf = fopen($newfname, "wb");
            $totalSize = 0;
            $chunkSize = 1024 * 50; // 50KB
            while (!feof($file)) {
                $data = fread($file, $chunkSize);
                fwrite($newf, $data);
                $totalSize += strlen($data);
                // فقط به جهت نمایش یک پیام
                echo "<div class='message'>دانلود: " . round($totalSize / (1024 * 1024), 2) . " MB</div>";
                flush(); // فرستادن خروجی به مرورگر
                ob_flush(); // فرستادن خروجی به مرورگر
            }
            fclose($file);
            fclose($newf);
            echo "<div class='message'>دانلود فایل به اتمام رسید! فایل با نام <strong>$newfname</strong> ذخیره شد.</div>";
        } else {
            echo "<div class='message'>خطا در دانلود فایل. لطفاً مطمئن شوید که لینک درست است.</div>";
        }
    }
    ?>

    <form method="post" action="">
        <label for="file_url">لینک فایل:</label>
        <input type="text" id="file_url" name="file_url" placeholder="لینک فایل را وارد کنید" required>
        <input type="submit" value="دانلود فایل">
    </form>
</div>

</body>
</html>
